//---------------------------------------------------------------------------
#ifndef TCompareItemH
#define TCompareItemH
#include <Classes.hpp>
//---------------------------------------------------------------------------
struct TCompareItem
{
public:
	enum {
		RESULT_NONE,
		RESULT_CREATED,
		RESULT_MODIFIED,
		RESULT_NOT_MODIFIED,
		RESULT_AMBIGUOUS,
		RESULT_ERROR,
	};
private:
protected:
	__int64 __fastcall GetTimeRemInDays() const;
public:
	AnsiString SrcName;
	AnsiString DstName;
	__int64 SizeRem;
	__int64 TimeRem;
	bool Duplicates;
	int Result;
	__fastcall TCompareItem();
	__fastcall TCompareItem(const TCompareItem& ASrc);
	virtual __fastcall ~TCompareItem();
	TCompareItem& __fastcall operator=(const TCompareItem& ASrc);
	bool __fastcall operator==(const TCompareItem& ASrc) const;
	bool __fastcall operator!=(const TCompareItem& ASrc) const;
	__property __int64 TimeRemInDays = {read=GetTimeRemInDays};
};
//---------------------------------------------------------------------------
#endif
