//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "TFindItemOptions.h"
#pragma package(smart_init)
//----------------------------------------------------------------------------
// struct TFindItemOptions
//----------------------------------------------------------------------------
__fastcall TFindItemOptions::TFindItemOptions() :
	FindText(),
	MatchAbsoluteName(false),
	Down(true),
	FindAll(false)
{
	// do nothing
}
//----------------------------------------------------------------------------
__fastcall TFindItemOptions::TFindItemOptions(const TFindItemOptions& ASrc) :
	FindText(),
	MatchAbsoluteName(false),
	Down(true),
	FindAll(false)
{
	*this = ASrc;
}
//----------------------------------------------------------------------------
__fastcall TFindItemOptions::~TFindItemOptions()
{
	// do nothing
}
//----------------------------------------------------------------------------
TFindItemOptions& __fastcall TFindItemOptions::operator=(
	const TFindItemOptions& ASrc)
{
	if(&ASrc != this) {
		FindText = ASrc.FindText;
		MatchAbsoluteName = ASrc.MatchAbsoluteName;
		Down = ASrc.Down;
		FindAll = ASrc.FindAll;
	}
	return *this;
}
//----------------------------------------------------------------------------
bool __fastcall TFindItemOptions::operator==(
	const TFindItemOptions& ASrc) const
{
	return
		FindText == ASrc.FindText &&
		MatchAbsoluteName == ASrc.MatchAbsoluteName &&
		Down == ASrc.Down &&
		FindAll == ASrc.FindAll;
}
//----------------------------------------------------------------------------
bool __fastcall TFindItemOptions::operator!=(
	const TFindItemOptions& ASrc) const
{
	return !(*this == ASrc);
}
//----------------------------------------------------------------------------
