//---------------------------------------------------------------------------
#ifndef TMainFormH
#define TMainFormH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <Menus.hpp>
#include <ImgList.hpp>
#include <ToolWin.hpp>
#include <Dialogs.hpp>
#include "TFindItemOptions.h"
#include "TViewOptions.h"
//---------------------------------------------------------------------------
class TOpenDialogList;
class TFileHistory;
class TMainForm : public TForm
{
__published:
	TMainMenu *MainMenu1;
	TMenuItem *FileM1;
	TMenuItem *CompareM1;
	TMenuItem *SaveListAsM1;
	TMenuItem *HistoryM1;
	TMenuItem *HistoryItemM1;
	TMenuItem *HistoryItemM2;
	TMenuItem *HistoryItemM3;
	TMenuItem *HistoryItemM4;
	TMenuItem *HistoryItemM5;
	TMenuItem *HistoryItemM6;
	TMenuItem *HistoryItemM7;
	TMenuItem *HistoryItemM8;
	TMenuItem *ClearM1;
	TMenuItem *ExitM1;
	TMenuItem *EditM1;
	TMenuItem *CopyM1;
	TMenuItem *SourceM1;
	TMenuItem *DestinationM1;
	TMenuItem *DeleteM1;
	TMenuItem *SelectM1;
	TMenuItem *AllM1;
	TMenuItem *NoneM1;
	TMenuItem *InvertM1;
	TMenuItem *SearchM1;
	TMenuItem *FindM1;
	TMenuItem *FindNextM1;
	TMenuItem *FindPreviousM1;
	TMenuItem *SortAscendM1;
	TMenuItem *ByNameM1;
	TMenuItem *ByDirectoryM1;
	TMenuItem *ByExtensionM1;
	TMenuItem *BySizeRemainderM1;
	TMenuItem *ByTimeRemainderM1;
	TMenuItem *ByResultM1;
	TMenuItem *ByAbsoluteNameM1;
	TMenuItem *SortDescendM1;
	TMenuItem *ByNameM2;
	TMenuItem *ByDirectoryM2;
	TMenuItem *ByExtensionM2;
	TMenuItem *BySizeRemainderM2;
	TMenuItem *ByTimeRemainderM2;
	TMenuItem *ByResultM2;
	TMenuItem *ByAbsoluteNameM2;
	TMenuItem *ExploreM1;
	TMenuItem *SourceM2;
	TMenuItem *DestinationM2;
	TMenuItem *BothM1;
	TMenuItem *PropertiesM1;
	TMenuItem *SourceM3;
	TMenuItem *DestinationM3;
	TMenuItem *BothM2;
	TMenuItem *SizeRemaindersM1;
	TMenuItem *ViewM1;
	TMenuItem *ResizeListColumnsM1;
	TMenuItem *ToolbarM1;
	TMenuItem *StatusBarM1;
	TMenuItem *LastPositionM1;
	TMenuItem *TopmostM1;
	TMenuItem *DefaultM1;
	TMenuItem *OperationsM1;
	TMenuItem *PerformToSelectionM1;
	TMenuItem *PerformToAllM1;
	TMenuItem *HelpM1;
	TMenuItem *HelpM2;
	TMenuItem *AboutM1;
	TMenuItem *SeparatorM1;
	TMenuItem *SeparatorM2;
	TMenuItem *SeparatorM3;
	TMenuItem *SeparatorM4;
	TMenuItem *SeparatorM5;
	TMenuItem *SeparatorM6;
	TMenuItem *SeparatorM7;
	TMenuItem *SeparatorM8;
	TMenuItem *SeparatorM9;
	TMenuItem *SeparatorM10;
	TMenuItem *SeparatorM11;
	TMenuItem *SeparatorM12;
	TMenuItem *SeparatorM13;
	TPopupMenu *PopupMenu1;
	TMenuItem *CopyP1;
	TMenuItem *SourceP1;
	TMenuItem *DestinationP1;
	TMenuItem *DeleteP1;
	TMenuItem *SelectP1;
	TMenuItem *AllP1;
	TMenuItem *NoneP1;
	TMenuItem *InvertP1;
	TMenuItem *SearchP1;
	TMenuItem *FindP1;
	TMenuItem *FindNextP1;
	TMenuItem *FindPreviousP1;
	TMenuItem *ExploreP1;
	TMenuItem *SourceP2;
	TMenuItem *DestinationP2;
	TMenuItem *BothP1;
	TMenuItem *Properties1;
	TMenuItem *SourceP3;
	TMenuItem *DestinationP3;
	TMenuItem *BothP2;
	TMenuItem *SizeRemaindersP1;
	TMenuItem *SeparatorP1;
	TMenuItem *SeparatorP2;
	TMenuItem *SeparatorP3;
	TToolBar *ToolBar1;
	TToolButton *CompareT1;
	TToolButton *CopySourceT1;
	TToolButton *CopyDestinationT1;
	TToolButton *DeleteItemsT1;
	TToolButton *SelectAllT1;
	TToolButton *FindT1;
	TToolButton *ResizeListColumnsT1;
	TToolButton *PerformToAllT1;
	TToolButton *PerformToSelectionT1;
	TToolButton *SeparatorT1;
	TToolButton *SeparatorT2;
	TToolButton *SeparatorT3;
	TToolButton *SeparatorT4;
	TImageList *ImageList1;
	TPanel *Panel1;
	TListView *ListView1;
	TStatusBar *StatusBar1;
	TOpenDialog *OpenDialog1;
	TSaveDialog *SaveDialog1;
	TSaveDialog *SaveDialog2;
	void __fastcall ApplicationIdle(TObject* ASender, bool& ADone);
	void __fastcall FormCloseQuery(TObject* ASender, bool& ACanClose);
	void __fastcall CompareM1Click(TObject* ASender);
	void __fastcall SaveListAsM1Click(TObject* ASender);
	void __fastcall HistoryM1Click(TObject* ASender);
	void __fastcall ClearM1Click(TObject* ASender);
	void __fastcall ExitM1Click(TObject* ASender);
	void __fastcall CopyM1Click(TObject* ASender);
	void __fastcall DeleteM1Click(TObject* ASender);
	void __fastcall SelectM1Click(TObject* ASender);
	void __fastcall SearchM1Click(TObject* ASender);
	void __fastcall SortAscendM1Click(TObject* ASender);
	void __fastcall SortDescendM1Click(TObject* ASender);
	void __fastcall ExploreM1Click(TObject* ASender);
	void __fastcall PropertiesM1Click(TObject* ASender);
	void __fastcall ViewM1Click(TObject* ASender);
	void __fastcall ResizeListColumnsM1Click(TObject* ASender);
	void __fastcall OperationsM1Click(TObject* ASender);
	void __fastcall HelpM2Click(TObject* ASender);
	void __fastcall AboutM1Click(TObject* ASender);
	void __fastcall PopupMenu1Click(TObject* ASender);
	void __fastcall ToolButtonClick(TObject* ASender);
	void __fastcall ListView1Deletion(TObject* ASender, TListItem* AItem);
	void __fastcall ListView1SelectItem(TObject* ASender, TListItem* AItem,
		bool ASelected);
	void __fastcall ListView1ColumnClick(TObject* ASender,
		TListColumn* AColumn);
	void __fastcall SizeRemaindersM1Click(TObject* ASender);
	void __fastcall CompareDialogSelectFile(TObject* ASender,
		AnsiString& AFileName, int AId, bool& ASelected);
	void __fastcall CompareDialogFileAccess(TObject* ASender,
		AnsiString AFileName, int AId);
	void __fastcall CompareThreadProgress(TObject* ASender, int AProcessed,
		int AAll);
	void __fastcall CompareThreadTerminate(TObject* ASender);
	void __fastcall FileHistoryChange(TObject* ASender);
private:
	enum {
		SELECTFILES_SAVE_LIST_AS = 0,
		SELECTFILES_COMPARE_IMPORT,
		SELECTFILES_COMPARE_EXPORT,
		SELECTFILES_COUNT,
	};
	static const int SORT_BY_NAME = 1 << 0;
	static const int SORT_BY_DIRECTORY = 1 << 1;
	static const int SORT_BY_EXTENSION = 1 << 2;
	static const int SORT_BY_SIZE_REMAINDER = 1 << 3;
	static const int SORT_BY_TIME_REMAINDER = 1 << 4;
	static const int SORT_BY_DUPLICATES = 1 << 5;
	static const int SORT_BY_RESULT = 1 << 6;
	static const int SORT_BY_ABSOLUTE_NAME = 1 << 7;
	static const int SORT_DESCEND = 1 << 8;
	enum {
		ACCESSITEMS_EXPLORE,
		ACCESSITEMS_PROPERTIES,
	};
	TOpenDialogList* FOpenDialogs;
	TList* FFileHistoryMenuItems;
	TFileHistory* FFileHistory;
	TViewOptions FViewOptions;
	static int CALLBACK CompareItem(LPARAM ALParam1, LPARAM ALParam2,
		LPARAM ALParam);
	void __fastcall CompareFiles(AnsiString AFileName);
	bool __fastcall ClearList(bool AConfirm);
	void __fastcall FindItem(TFindItemOptions AOptions);
	void __fastcall SortItems(int AFlags);
	void __fastcall AccessItems(bool ASrc, bool ADst, int AOperation);
	void __fastcall InitOpenDialogs();
	void __fastcall UninitOpenDialogs();
	void __fastcall InitFileHistory();
	void __fastcall UninitFileHistory();
	void __fastcall InitCompareDialog();
	void __fastcall UninitCompareDialog();
	void __fastcall ProcessCommandParams();
	void __fastcall LoadSettings();
	bool __fastcall TryLoadSettings();
	void __fastcall SaveSettings();
	bool __fastcall TrySaveSettings();
protected:
	static AnsiString __fastcall ResultToStr(int AResult);
	void __fastcall UpdateEnabled(bool AForceAll);
	void __fastcall UpdateItem(int AIndex);
	void __fastcall ItemCountChange();
	void __fastcall SetViewOptions(TViewOptions AViewOptions);
	void __fastcall ViewOptionsChange();
	void __fastcall FilesDrop(const TStrings* AFiles);
	void __fastcall WMDropFiles(TWMDropFiles& AMessage);
public:
	__fastcall TMainForm(TComponent* AOwner);
	virtual __fastcall ~TMainForm();
	void __fastcall ShowStatus(AnsiString AStatus);
	__property TOpenDialogList* OpenDialogs = {read=FOpenDialogs};
	__property TList* FileHistoryMenuItems = {read=FFileHistoryMenuItems};
	__property TFileHistory* FileHistory = {read=FFileHistory};
	__property TViewOptions ViewOptions = {read=FViewOptions,
		write=SetViewOptions};
	BEGIN_MESSAGE_MAP
		MESSAGE_HANDLER(WM_DROPFILES, TWMDropFiles, WMDropFiles)
	END_MESSAGE_MAP(TForm)
};
//---------------------------------------------------------------------------
extern PACKAGE TMainForm* MainForm;
//---------------------------------------------------------------------------
#endif
