//---------------------------------------------------------------------------
#ifndef TOpenDialogListH
#define TOpenDialogListH
#include <Classes.hpp>
//---------------------------------------------------------------------
class TOpenDialogList : public TList
{
private:
	AnsiString FInitialDir;
protected:
	static bool __fastcall IsAbsoluteFileName(AnsiString AFileName);
	TOpenDialog* __fastcall GetItem(int AIndex);
	void __fastcall SetItem(int AIndex, TOpenDialog* AItem);
	TOpenDialog** __fastcall GetList() const;
public:
	__fastcall TOpenDialogList();
	int __fastcall Add(TOpenDialog* AItem);
	void __fastcall Assign(TOpenDialogList* AListA,
		TListAssignOp AOperator = laCopy,
		TOpenDialogList* AListB = NULL);
	TOpenDialogList* __fastcall Expand();
	TOpenDialog* __fastcall Extract(TOpenDialog* AItem);
	TOpenDialog* __fastcall First();
	int __fastcall IndexOf(TOpenDialog* AItem);
	void __fastcall Insert(int AIndex, TOpenDialog* AItem);
	TOpenDialog* __fastcall Last();
	int __fastcall Remove(TOpenDialog* AItem);
	bool __fastcall SelectFiles(int AIndex, AnsiString& AFileName,
		TStrings* AFiles = NULL);
	bool __fastcall SelectDirectory(AnsiString ACaption,
		AnsiString& ADirectory);
	__property TOpenDialog* Items[int AIndex] = {read=GetItem,
		write=SetItem};
	__property TOpenDialog** List = {read=GetList};
	__property AnsiString InitialDir = {read=FInitialDir,
		write=FInitialDir};
};
//---------------------------------------------------------------------
#endif
