//----------------------------------------------------------------------------
#ifndef TProgressDialogH
#define TProgressDialogH
//----------------------------------------------------------------------------
#include <vcl\ExtCtrls.hpp>
#include <vcl\Buttons.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Controls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\Graphics.hpp>
#include <vcl\Classes.hpp>
#include <vcl\SysUtils.hpp>
#include <vcl\Windows.hpp>
#include <vcl\System.hpp>
#include <ComCtrls.hpp>
//----------------------------------------------------------------------------
class TProgressDialog : public TForm
{
__published:
	TLabel *Label1;
	TProgressBar *ProgressBar1;
	TButton *Button1;
	void __fastcall FormShow(TObject* ASender);
	void __fastcall FormCloseQuery(TObject* ASender, bool& ACanClose);
private:
	TThread* FThread;
protected:
	int __fastcall GetPercentDone() const;
	void __fastcall SetPercentDone(int APercentDone);
public:
	virtual __fastcall TProgressDialog(TComponent* AOwner);
	void __fastcall Start(TThread* AThread);
	void __fastcall Finish(bool ACanClose);
	void __fastcall ShowMessage(AnsiString AMessage);
	void __fastcall ShowProgress(int AProcessed, int AAll);
	__property int PercentDone = {read=GetPercentDone, write=SetPercentDone};
};
//----------------------------------------------------------------------------
extern PACKAGE TProgressDialog* ProgressDialog;
//----------------------------------------------------------------------------
#endif
