//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "TViewOptions.h"
#pragma package(smart_init)
//---------------------------------------------------------------------------
// struct TViewOptions
//---------------------------------------------------------------------------
__fastcall TViewOptions::TViewOptions() :
	ToolBar(true),
	StatusBar(true),
	LastPosition(false),
	Topmost(false)
{
	// do nothing
}
//---------------------------------------------------------------------------
__fastcall TViewOptions::TViewOptions(const TViewOptions& ASrc) :
	ToolBar(true),
	StatusBar(true),
	LastPosition(false),
	Topmost(false)
{
	*this = ASrc;
}
//---------------------------------------------------------------------------
__fastcall TViewOptions::~TViewOptions()
{
	// do nothing
}
//---------------------------------------------------------------------------
TViewOptions& __fastcall TViewOptions::operator=(const TViewOptions& ASrc)
{
	if(&ASrc != this) {
		ToolBar = ASrc.ToolBar;
		StatusBar = ASrc.StatusBar;
		LastPosition = ASrc.LastPosition;
		Topmost = ASrc.Topmost;
	}
	return *this;
}
//---------------------------------------------------------------------------
bool __fastcall TViewOptions::operator==(const TViewOptions& ASrc) const
{
	return
		ToolBar == ASrc.ToolBar &&
		StatusBar == ASrc.StatusBar &&
		LastPosition == ASrc.LastPosition &&
		Topmost == ASrc.Topmost;
}
//---------------------------------------------------------------------------
bool __fastcall TViewOptions::operator!=(const TViewOptions& ASrc) const
{
	return !(*this == ASrc);
}
//---------------------------------------------------------------------------

