//---------------------------------------------------------------------------
#ifndef MySysUtilsH
#define MySysUtilsH
#include <Classes.hpp>
//---------------------------------------------------------------------------
// control utilities
//---------------------------------------------------------------------------
extern void __fastcall SaveListItemsToFile(AnsiString AFileName,
	const TListView* AListView, bool AIncludeColumns);
//---------------------------------------------------------------------------
// date and time utilities
//---------------------------------------------------------------------------
// file utilities
//---------------------------------------------------------------------------
extern AnsiString __fastcall ShortFileNameToLongFileName(
	AnsiString AShortFileName);
extern bool __fastcall ShowFileProperties(AnsiString AFileName);
extern bool __fastcall MatchFileName(AnsiString AFileName, AnsiString AMask);
extern AnsiString __fastcall ExtractFileLink(AnsiString AFileName);
//---------------------------------------------------------------------------
// string utilities
//---------------------------------------------------------------------------
extern AnsiString __fastcall FormatInt(AnsiString ASrc);
extern AnsiString __fastcall EnsureSign(AnsiString AStr);
extern void __fastcall AnsiTokenizeStr(TStrings* ATokens, AnsiString AStr,
	char ADelimiter);
//---------------------------------------------------------------------------
// variable type utilities
//---------------------------------------------------------------------------
extern DWORDLONG __fastcall MakeDwordLong(DWORD ALow, DWORD AHigh);
extern void __fastcall MakeDwords(DWORDLONG ADwordLong, DWORD& ALow,
	DWORD& AHigh);
extern int __fastcall WrapInc(int AValue, int AMinValue, int AMaxValue);
extern int __fastcall WrapDec(int AValue, int AMinValue, int AMaxValue);
extern void __fastcall FlipBool(bool& AValue);
//---------------------------------------------------------------------------
#endif
