//----------------------------------------------------------------------------
#ifndef TFindItemDialogH
#define TFindItemDialogH
//----------------------------------------------------------------------------
#include <vcl\ExtCtrls.hpp>
#include <vcl\Buttons.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Controls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\Graphics.hpp>
#include <vcl\Classes.hpp>
#include <vcl\SysUtils.hpp>
#include <vcl\Windows.hpp>
#include <vcl\System.hpp>
#include "TFindItemOptions.h"
//----------------------------------------------------------------------------
class TFindItemDialog : public TForm
{
__published:
	TLabel *Label1;
	TEdit *Edit1;
	TCheckBox *CheckBox1;
	TRadioGroup *RadioGroup1;
	TButton *Button1;
	TButton *Button2;
	TButton *Button3;
	void __fastcall FormShow(TObject* ASender);
	void __fastcall FormCloseQuery(TObject* ASender, bool& ACanClose);
	void __fastcall Edit1Change(TObject* ASender);
private:
	TFindItemOptions FOptions;
	struct {
		TFindItemOptions Options;
	} FBackup;
	static int __fastcall DownToIndex(bool ADown);
	static bool __fastcall IndexToDown(int AIndex);
protected:
	void __fastcall ReflectParams();
	bool __fastcall UpdateParams();
	void __fastcall BackupParams();
	void __fastcall RestoreParams();
	void __fastcall UpdateEnabled();
	void __fastcall SetOptions(TFindItemOptions AOptions);
	void __fastcall OptionsChange();
	void __fastcall ReflectOptions();
	bool __fastcall UpdateOptions();
public:
	virtual __fastcall TFindItemDialog(TComponent* AOwner);
	virtual __fastcall ~TFindItemDialog();
	bool __fastcall Execute();
	__property TFindItemOptions Options = {read=FOptions, write=SetOptions};
};
//----------------------------------------------------------------------------
extern PACKAGE TFindItemDialog* FindItemDialog;
//----------------------------------------------------------------------------
#endif
